// test2400Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "test2400.h"
#include "test2400Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest2400Dlg dialog

CTest2400Dlg::CTest2400Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest2400Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest2400Dlg)
	m_value = _T("");
	m_resource = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTest2400Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTest2400Dlg)
	DDX_Control(pDX, IDC_BUTTON1, m_init);
	DDX_Control(pDX, IDC_BUTTON3, m_close);
	DDX_Control(pDX, IDC_BUTTON2, m_measure);
	DDX_Text(pDX, IDC_MEASURED, m_value);
	DDX_Text(pDX, IDC_RESOURCE, m_resource);
	DDV_MaxChars(pDX, m_resource, 25);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTest2400Dlg, CDialog)
	//{{AFX_MSG_MAP(CTest2400Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest2400Dlg message handlers

BOOL CTest2400Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// populate our edit box with a typical VISA resource

	m_resource.Format("%s","GPIB0::24::INSTR");
	UpdateData(FALSE);  // update the dialog to display this value
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTest2400Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTest2400Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTest2400Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTest2400Dlg::OnButton1() 
{
	ViStatus nErr;
	ViPInt32 temp = new ViInt32();
	sess = new ViSession();
	char ResourceName[25];
	
	// read in the resource name string to use
	UpdateData(TRUE);  // 
	strcpy(ResourceName,m_resource);

//	default ResourceName = "GPIB0::24::INSTR";
//  set from OnInitDialog.....
//	typical resource name for RS-232: "ASRL1::INSTR"
	nErr = Ke24xx_init (ResourceName,temp,sess);
	if (nErr != 0)
	{   // there was an error, display the error message
		DisplayError(*sess,nErr);
	}
	else
    {  // successful Init, enable other buttons
     m_init.EnableWindow(FALSE);  // disable the init button
     m_measure.EnableWindow(TRUE);
	 m_close.EnableWindow(TRUE);
    // reset the instrument
	nErr = Ke24xx_reset(*sess);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	}  // if
	



}

void CTest2400Dlg::DisplayError(ViSession sesn, ViStatus nErr)
{
	ViChar errMsg[256];
	ViStatus err;
	ViPInt32 code = new ViInt32();
	if (nErr == KE24XX_DEVICE_ERROR)
	{
		err = Ke24xx_GetLastError(sesn, code, errMsg);
		CString temp;
		temp.Format("Error = %i",code);
		temp += "  " + CString(errMsg);
		AfxMessageBox(temp);
	}
	else
	{
		err = Ke24xx_error_message(sesn, nErr, errMsg);
		if (err != 0)
		{
			CString temp;
			temp.Format("Error = %x",nErr);
			AfxMessageBox(temp);
        }
		else
		{
			CString temp;
			temp.Format("Error = %x",nErr);
			temp += "  " + CString(errMsg);
			AfxMessageBox(temp);
		}
	}
}

void CTest2400Dlg::OnButton2() 
{
	ViStatus nErr;

	// configure which function will be measured, V or I or R
	// we will measure current
		nErr = Ke24xx_SelectSenseFunc(*sess, VI_FALSE, VI_TRUE, VI_FALSE);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	// source voltage
	nErr = Ke24xx_ConfigureSourceMode(*sess, KE24XX_SOURCE_VOLTAGE_FUNCTION, KE24XX_SOURCE_FIXED_MODE, KE24XX_SOURCE_DC_SHAPE, KE24XX_AUTO_RANGE);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	// delay
	nErr = Ke24xx_ConfigureSourceDelay(*sess, VI_FALSE, 0);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	// controls when auto ranging will take place. See Hardware Guide: 'Auto Range Change Mode'
	nErr = Ke24xx_SetAutoRangeChangeMode(*sess, KE24XX_RCMODE_SINGLE);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	// compliance of 100 mA
	nErr = Ke24xx_ConfigureSourceCompliance(*sess, KE24XX_SOURCE_VOLTAGE_FUNCTION, 0.1);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	// source 1 volt
	nErr = Ke24xx_ConfigureSourceLevel(*sess, KE24XX_SOURCE_VOLTAGE_FUNCTION, 1, KE24XX_SOURCE_LEVEL_IMMEDIATE);
	if (nErr != 0)
		DisplayError(*sess,nErr);

		// turn output ON
	nErr = Ke24xx_EnableSourceOutput(*sess, VI_TRUE);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	ViInt32 numberOfReadings;
    float values[100];

    numberOfReadings = 1;
	// take a measurement
		nErr = Ke24xx_Read(*sess, 2, &numberOfReadings, values);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	m_value.Format("%8.5f",values[0]);
	UpdateData(FALSE);  // update the dialog with our measurement


	// turn output off
	nErr = Ke24xx_EnableSourceOutput(*sess, VI_FALSE);
	if (nErr != 0)
		DisplayError(*sess,nErr);
}

void CTest2400Dlg::OnButton3() 
{
	ViStatus nErr;
	nErr = Ke24xx_close(*sess);
	if (nErr != 0)
		DisplayError(*sess,nErr);

	CWnd::DestroyWindow();  // close down this application
	
}
